
% EE1 - PERSONALITY v3, 2016-08-23

clear all
clc

global B_backup; % this one is for storing B in case iterations are interrupted with ctrl-c


%% ****************************  loading data  ****************************


EstimOpt.fnameinput = ('data_EE1_01');
DATA = load(EstimOpt.fnameinput);


%% ****************************  data transformations  ****************************


DATA.SQ = DATA.alt == 1;
DATA.AS_MPA = DATA.as == 1;
DATA.AS_WP = DATA.as == 2;
DATA.AS_EWP = DATA.as == 3;
DATA.WS_MPA = DATA.ws == 1;
DATA.WS_WP = DATA.ws == 2;
DATA.WS_EWP = DATA.ws == 3;

DATA.been = DATA.q1 == 1; % Have you ever been to Hiiumaa? (1 = yes);
DATA.heardBottom = DATA.q2 == 1; % heard that the Hiiumaa shoals have valuable habitats on their bottom?
DATA.heardBirds = DATA.q3 == 1; % heard that the Hiiumaa shoals are important staging, foraging and wintering areas for migratory birds?
DATA.heardDuck = DATA.q4 == 1; % heard that the Apollo shoal is particularly important for the Long-tailed Duck
DATA.heardMPA = DATA.q5 == 1; % heard that there has been a proposal to create marine protected area on Apollo shoal
DATA.shProtectY = DATA.q6 == 1; %In general, do you think we should protect marine waters in Estonia? (1 - yes, 2 - no, 3 - DK)
DATA.shProtectN = DATA.q6 == 2;
DATA.shProtectDK = DATA.q6 == 3;
DATA.attLimitsLM = DATA.q7 == 1; % Estonian marine areas use limitations enough? (1 - too much, 2 - about right, 3 - too little, 4 - DK)
DATA.attLimitsAR = DATA.q7 == 2;
DATA.attLimitsTL = DATA.q7 == 3;
DATA.attLimitsDK = DATA.q7 == 4;
DATA.wantMPAY = DATA.q8 == 1; % in favour of establishment of MPA on Hiiumaa shoals? (1 - Yes, on all of the shoals, 2 - Yes, only on Apollo shoal, 3 - Yes, only on Western shoals, 4 - No, 5 - DK)
DATA.wantMPAA = DATA.q8 == 2;
DATA.wantMPAW = DATA.q8 == 3;
DATA.wantMPAN = DATA.q8 == 4;
DATA.wantMPADK = DATA.q8 == 5;
DATA.enoughREN = (DATA.q9_1 - mean(DATA.q9_1)) ./ std(DATA.q9_1); %There is already enough renewable energy consumed from renewable (26% of final energy consumption)
DATA.favEUtargetsREN = (DATA.q9_2 - mean(DATA.q9_2)) ./ std(DATA.q9_2); %I am in favour of the EU targets for renewable energy sources
DATA.supportREN = (DATA.q9_3 - mean(DATA.q9_3)) ./ std(DATA.q9_3); % The production of renewable energy should be supported in Estonia
DATA.supportWIND = (DATA.q9_4 - mean(DATA.q9_4)) ./ std(DATA.q9_4); %The wind energy production should be supported by consumers as today
DATA.supportOtherREN = (DATA.q9_5 - mean(DATA.q9_5)) ./ std(DATA.q9_5); %Productuion of other types of renewable energy should be supported, but not the wind energy
DATA.useOilShale = (DATA.q9_6 - mean(DATA.q9_6)) ./ std(DATA.q9_6); %We should use oil shale potential as a priority for energy and electricity production
DATA.wantWPY = DATA.q10 == 1; %	Are you in favour of establishment of Hiiumaa wind park? (1 - Yes, on all of the shoals, 2 - Yes, only on Apollo shoal, 3 - Yes, only on Western shoals, 4 - No, 5 - DK)
DATA.wantWPA = DATA.q10 == 2;
DATA.wantWPW = DATA.q10 == 3;
DATA.wantWPN = DATA.q10 == 4;
DATA.wantWPDK = DATA.q10 == 5;
DATA.wantEWPY = DATA.q11 == 1; % Are you in general in favour of establishment of environmentally friendly wind park on Hiiumaa shoals? (1 - Yes, on all of the shoals, 2 - Yes, only on Apollo shoal, 3 - Yes, only on Western shoals, 4 - No, 5 - DK)
DATA.wantEWPA = DATA.q11 == 2;
DATA.wantEWPW = DATA.q11 == 3;
DATA.wantEWPN = DATA.q11 == 4;
DATA.wantEWPDK = DATA.q11 == 5;

% q14 - protest reasons - use for LV?

% q15 - important / unimporatant reasons

% q16 - personality scale

% q17 - knowledge test

DATA.age = 2013 - DATA.q18;
DATA.female = DATA.q19 == 1;
DATA.hhsize = DATA.q20;
DATA.hhc = DATA.q21;
DATA.edu1 = DATA.q22 == 1;
DATA.edu2 = DATA.q22 == 2;
DATA.edu3 = DATA.q22 == 3;
DATA.edu4 = DATA.q22 == 4;
DATA.edu = ((DATA.edu1 + DATA.edu2*2 + DATA.edu3*3 + DATA.edu4*4)-mean(DATA.edu1 + DATA.edu2*2 + DATA.edu3*3 + DATA.edu4*4))./std(DATA.edu1 + DATA.edu2*2 + DATA.edu3*3 + DATA.edu4*4);
DATA.empFT = DATA.q23 == 1;
DATA.empPT = DATA.q23 == 2;
DATA.empRET = DATA.q23 == 3;
DATA.empST = DATA.q23 == 4;
DATA.empHE = DATA.q23 == 5;
DATA.empSE = DATA.q23 == 6;
DATA.empUN = DATA.q23 == 7;
DATA.emp = DATA.empFT + DATA.empPT + DATA.empSE;
DATA.inc1 = DATA.q25 == 1;
DATA.inc2 = DATA.q25 == 2;
DATA.inc3 = DATA.q25 == 3;
DATA.inc4 = DATA.q25 == 4;
DATA.inc5 = DATA.q25 == 5;
DATA.inc = (DATA.inc1*400 + DATA.inc2*700 + DATA.inc3*900 + DATA.inc4*1000 + DATA.inc5*1600)./1000;




DATA.wantMPAY2 = DATA.wantMPAY | DATA.wantMPAA | DATA.wantMPAW;
DATA.wantWPY2 = DATA.wantWPY | DATA.wantWPA | DATA.wantWPW;
DATA.wantEWPY2 = DATA.wantEWPY | DATA.wantEWPA | DATA.wantEWPW;

DATA.wantMPAA2 = DATA.wantMPAA | DATA.wantMPAY;
DATA.wantMPAW2 = DATA.wantMPAW | DATA.wantMPAY;
DATA.wantWPA2 = DATA.wantWPA | DATA.wantWPY;
DATA.wantWPW2 = DATA.wantWPW | DATA.wantWPY;
DATA.wantEWPA2 = DATA.wantEWPA | DATA.wantEWPY;
DATA.wantEWPW2 = DATA.wantEWPW | DATA.wantEWPY;

DATA.wantMPA2 = DATA.wantMPAA2 | DATA.wantMPAW2;
DATA.wantWP2 = DATA.wantWPA2 | DATA.wantWPW2;
DATA.wantEWP2 = DATA.wantEWPA2 | DATA.wantEWPW2;

% DATA.Xc = [DATA.wantMPAY, DATA.wantMPAA, DATA.wantMPAW, DATA.wantWPY, DATA.wantWPA, DATA.wantWPW, DATA.wantEWPY, DATA.wantEWPA, DATA.wantEWPW, DATA.empUN, DATA.empHE, DATA.empST, DATA.age, DATA.female, DATA.hhsize, DATA.hhc, DATA.edu, DATA.inc];
% DATA.Xc = [DATA.wantMPAY, DATA.wantMPAA, DATA.wantMPAW, DATA.wantWPY, DATA.wantWPA, DATA.wantWPW, DATA.wantEWPY, DATA.wantEWPA, DATA.wantEWPW];


% DATA.Xc = [DATA.Xc,DATA.inc];
% DATA.shProtectY,DATA.favEUtargetsREN ,DATA.useOilShale ,DATA.attLimitsTL ,DATA.heardDuck

% DATA.empUN, DATA.empHE, DATA.empST,
% DATA.age, DATA.female, DATA.hhc, DATA.hhsize, DATA.edu, DATA.inc
% DATA.Xc = [DATA.wantMPA2,DATA.wantWP2,DATA.wantEWP2];
% DATA.Xc = [DATA.Xc, DATA.empUN, DATA.empHE, DATA.empST];
% DATA.Xc = [DATA.Xc, DATA.shProtectY, DATA.favEUtargetsREN, DATA.useOilShale,DATA.attLimitsTL,DATA.heardDuck];

% DATA.Xc = (DATA.Xc - repmat(mean(DATA.Xc),size(DATA.Xc,1),1))./repmat(std(DATA.Xc),size(DATA.Xc,1),1);

EstimOpt.NamesA = {'SQ';'AS_MPA';'AS_WP';'AS_EWP';'WS_MPA';'WS_WP';'WS_EWP';'COST'};

% Extraversion: Add Q1 and a reverse coded Q6 (simplest way to reverse code for a 7-point scale is multiply by -1 and then add 8)
% Agreeableness: Add Q7 and a reverse coded Q2
% Conscientiousness: Add Q3 and a reverse coded Q8.
% Neuroticism: Add Q4 and a reverse coded Q9
% Openness to Experiences: Add Q5 and a reverse coded Q10

DATA.Extraversion = DATA.q16_1 + (-DATA.q16_6+8);
DATA.Extraversion = (DATA.Extraversion - mean(DATA.Extraversion))./std(DATA.Extraversion);
DATA.Agreeableness = DATA.q16_7 + (-DATA.q16_2+8);
DATA.Agreeableness = (DATA.Agreeableness - mean(DATA.Agreeableness))./std(DATA.Agreeableness);
DATA.Conscientiousness = DATA.q16_3 + (-DATA.q16_8+8);
DATA.Conscientiousness = (DATA.Conscientiousness - mean(DATA.Conscientiousness))./std(DATA.Conscientiousness);
DATA.Neuroticism = DATA.q16_4 + (-DATA.q16_9+8);
DATA.Neuroticism = (DATA.Neuroticism - mean(DATA.Neuroticism))./std(DATA.Neuroticism);
DATA.OpennessToExperiences = DATA.q16_5 + (-DATA.q16_10+8);
DATA.OpennessToExperiences = (DATA.OpennessToExperiences - mean(DATA.OpennessToExperiences))./std(DATA.OpennessToExperiences);

% interactions:
% DATA.X = matInt(DATA.X, [ones(size(DATA.Extraversion)) DATA.Extraversion DATA.Agreeableness DATA.Conscientiousness DATA.Neuroticism DATA.OpennessToExperiences]);
% EstimOpt.NamesA = {'SQ';'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'AS_MPA';'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'AS_WP';'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'AS_EWP';'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'WS_MPA';'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'WS_WP';'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'WS_EWP';'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'COST';'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'};

% interactions with constraints:
% DATA.X = [matInt(DATA.X(:,1), [ones(size(DATA.Extraversion)) DATA.Extraversion DATA.Agreeableness DATA.Conscientiousness DATA.Neuroticism DATA.OpennessToExperiences]), ...
%     DATA.X(:,2:end-1),...
%     matInt(DATA.X(:,end), [ones(size(DATA.Extraversion)) DATA.Extraversion DATA.Agreeableness DATA.Conscientiousness DATA.Neuroticism DATA.OpennessToExperiences])];
% EstimOpt.NamesA = {'SQ';'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'AS_MPA';... %'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'AS_WP';... %'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'AS_EWP';... %'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'WS_MPA';... %'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'WS_WP';... %'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'WS_EWP';... %'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'; ...
%     'COST';'  *Extraversion';'  *Agreeableness';'  *Conscientiousness';'  *Neuroticism';'  *OpennessToExperiences'};


% DATA.Xm = [DATA.Extraversion DATA.Agreeableness DATA.Conscientiousness DATA.Neuroticism DATA.OpennessToExperiences];
% EstimOpt.NamesM = {'Extraversion';'Agreeableness';'Conscientiousness';'Neuroticism';'OpennessToExperiences'};

% DATA.Xm = [DATA.age DATA.female DATA.hhsize DATA.hhc DATA.edu2 DATA.edu3 DATA.edu4  DATA.emp DATA.inc];
% EstimOpt.NamesM = {'age';'female';'hh size';'hh children';'edu2';'edu3';'edu4';'employed';'income'};
% DATA.Xm_std = std(DATA.Xm);
% DATA.Xm = DATA.Xm./DATA.Xm_std(ones(size(DATA.Xm,1),1),:);
% DATA.Xm_mean = mean(DATA.Xm);
% DATA.Xm = DATA.Xm - DATA.Xm_mean(ones(size(DATA.Xm,1),1),:);



% DATA.Xc = [DATA.wantMPAY2, DATA.wantWPY2, DATA.wantEWPY2];
% EstimOpt.NamesC = {'wantMPA';'wantWP';'wantEWP'};

%% ****************************  model specification  ****************************


DATA.Y = DATA.ans1;

DATA.X = [DATA.SQ, DATA.AS_MPA, DATA.AS_WP, DATA.AS_EWP, DATA.WS_MPA, DATA.WS_WP, DATA.WS_EWP, -DATA.c/10];



%% ****************************  specifying input ****************************

INPUT.Y = DATA.Y;
INPUT.Xa = DATA.X;
% INPUT.Xm = DATA.Xm;
% INPUT.Xc = DATA.Xc;
% INPUT.MissingInd = DATA.noans;
INPUT.Xmea = [DATA.q16_1, DATA.q16_6, DATA.q16_7, DATA.q16_2, DATA.q16_3, DATA.q16_8, DATA.q16_4, DATA.q16_9, DATA.q16_5, DATA.q16_10];


%% ****************************  sample characteristics ****************************

EstimOpt.NCT = 12; % Number of choice tasks per person
EstimOpt.NAlt = 3; % Number of alternatives
EstimOpt.NP = length(INPUT.Y)/EstimOpt.NCT/EstimOpt.NAlt;


%% **************************** estimation and optimization options ****************************

EstimOpt.eps = 1.e-9; % overall precision level

[INPUT, Results, EstimOpt, OptimOpt] = DataCleanDCE(INPUT,EstimOpt);

EstimOpt.NRep = 1e4; % number of draws for numerical simulation
% OptimOpt.MaxIter = 1e1; % maximum number of iterations

% OptimOpt.Algorithm = 'trust-region'; % 'quasi-newton';
% EstimOpt.NumGrad = 1; % 1
% OptimOpt.GradObj = 'off'; % 'off'
% OptimOpt.FinDiffType = 'central'; % 'forward'
% OptimOpt.Hessian = 'user-supplied'; % 'off'
% EstimOpt.HessEstFix = 1; % 0 = use optimization Hessian, 1 = use jacobian-based (BHHH) Hessian, 2 - use high-precision jacobian-based (BHHH) Hessian 3 - use numerical Hessian
% EstimOpt.ApproxHess = 0;


try

    
    EstimOpt.ProjectName = '6c';

    
    
    %% **************************** MNL ****************************
    
    
    Results.MNL = MNL(INPUT,Results,EstimOpt,OptimOpt);
    
    
    %% ****************************     MXL     ****************************

    
    EstimOpt.Dist = [1 0 0 0 0 0 0 0 1];
    EstimOpt.MNLDist = EstimOpt.Dist;
        
%     Results.MXL_d = MXL(INPUT,Results,EstimOpt,OptimOpt);
      
% log:
% Results.MXL_d.bhat = [-0.325838572254220;0.123532626736897;-1.29629886586525;0.544798026496648;0.475939933513559;-0.407252865550983;0.268020606252225;-0.645163904889759;2.92789878027512;1.55210867809001;1.90306431800485;0.802961564685857;1.14448282004413;1.70473312429324;0.702377473578927;4.35831655615394];
    

    %% ****************************     HMNL     ****************************
    
    EstimOpt.Dist = [0 0 0 0 0 0 0 1];
    EstimOpt.MNLDist = EstimOpt.Dist;
    
    EstimOpt.NLatent = 5;
    EstimOpt.MeaMatrix = [ 1 1 0 0 0 0 0 0 0 0; ...
        0 0 1 1 0 0 0 0 0 0; ...
        0 0 0 0 1 1 0 0 0 0; ...
        0 0 0 0 0 0 1 1 0 0; ...
        0 0 0 0 0 0 0 0 1 1];
    EstimOpt.MeaSpecMatrix = 2;
    
    EstimOpt.NamesMea = {'Q1', 'Q6', 'Q7', 'Q2', 'Q3', 'Q8', 'Q4', 'Q9', 'Q5', 'Q10'};
    EstimOpt.NamesLV = {'Extraversion', 'Agreeableness', 'Conscientiousness','Neuroticism','Openness to Experiences'};
    
   
% WTP-space: -18678.7807
% Results.HMNL.b0 = [1.07443628694015;-1.16018794451609;-2.39326447119641;-0.258658151388578;-0.669231238848173;-1.43715871447578;-0.524842282723670;1.08294275996552;2.76968363916645;-1.04194057553104;-1.38434908688560;-0.627184234403168;-1.24462440414819;-1.76543542285426;-0.771627769484032;-0.227220709342760;-0.0104601230172997;1.18663394622892;-0.533493766079791;-0.315674975572922;1.58649524489896;0.569428043090539;-0.180766739059090;0.628304592176491;-0.963225703046014;1.16445944928901;1.33975287754438;-0.0534172699347759;0.0637278905966397;0.316006882551178;0.608255052297904;-0.160086355631132;-0.971589746842217;1.18160247470945;1.22454134718336;-0.253859530810070;-0.103753299006387;-0.515628790012488;0.323859296050852;-0.205480894005913;0.498771408615704;-1.61480229406415;-4.04368369821005;0.476250894884252;-0.955075028074774;-3.03335571229129;0.129045062514259;1.23489811754576;-0.113793314326189;-1.73295023004298;-0.750193140813750;-0.508298891818616;-0.517995479416440;-0.0282812450843536;-0.209356740897572;0.105563046276376;-1.84054475806742;-0.331520546196125;-0.289299495264892;-0.537250497420205;-0.159350944852999;-0.235881115054878;0.0822398347585162;-2.38732877486822;-1.05535397549021;-0.865862606011735;-0.498159487580585;0.225285855320556;-0.0616469732655989;-0.0193246928024695;-1.42116100917385;-0.124390622402074;-0.339647601116973;-0.519370924084281;-0.0749796534801518;-0.304121119118251;-0.915192061955002;-2.90828236001150;-1.04516060997905;-0.823446543092414;-0.241194758617721;0.471655931918979;0.307430030578428;0.725853113492672;-1.09257214135638;0.0692141393064434;-0.122578330124247;-0.148074804136197;-0.621237117746011;-0.558519605811276;-0.588482506407559;-1.49599034048192;-0.133347141764945;-0.0333504551748372;-0.309514490762555;-0.0246904051042190;-0.527746186959952;0.762368250523703;-2.74620202195536;-0.346249563700857;-0.506020079502256;-0.188976020371649;0.181525526974732;0.155809995817378;-0.160309128690287;-2.18843433288315;-0.981368656114330;-0.500127825336683;-0.339175012110650;0.0419110594796066;-0.225229621860256;0.128752844496445;-1.23318440664791;-0.327495023332607;-0.334088978305713;-0.245367827488152;-0.347884400978890;-0.581996371842145];

% WTP-space constrained 1k: -19218.5428
%     EstimOpt.BActive = ones(size(Results.HMNL.b0));
%     EstimOpt.BActive(end-108:end-103) = 0;
%     EstimOpt.BActive(end-100:end-95) = 0;
%     EstimOpt.BActive(end-92:end-87) = 0;
%     EstimOpt.BActive(end-84:end-79) = 0;
%     EstimOpt.BActive(end-76:end-71) = 0;
%     Results.HMNL.b0 = Results.HMNL.b0 .* EstimOpt.BActive;
%     Results.HMNL.b0 = [11.0598344072615;-1.56452537582893;-5.41684035809059;1.49533842261463;-0.912997694870334;-3.92510477285290;0.306243190866763;0.243852412876661;13.1932946498479;0;0;0;0;0;0;-0.126217133800768;-1.87989013747464;0;0;0;0;0;0;0.0804305885874606;-2.80903433271031;0;0;0;0;0;0;-0.000351238935876485;-2.84905126394987;0;0;0;0;0;0;-0.0133328647005265;2.81870361765658;0;0;0;0;0;0;0.238207942025880;0.0148538071400040;-1.72197792092208;-0.758078063652696;-0.513047617029579;-0.523816983724968;-0.0365826314864505;-0.213180631565748;0.173911893093304;-1.84960521044550;-0.325312583161938;-0.283668722314872;-0.528911200380442;-0.147353484999492;-0.221604708874748;0.662238169788253;-2.83525884924466;-0.905382476466003;-0.708850333918192;-0.318720191721729;0.405751905346295;0.119506787786218;-0.334588687706335;-1.50906002475846;-0.0564481636878655;-0.276727802532491;-0.473389393671498;-0.0447040154554594;-0.291066063273497;-0.787877904826880;-2.76315248714211;-1.08233049258512;-0.868327831749657;-0.295523206830436;0.414125487542199;0.243939428048569;0.980162141840185;-1.23172767180970;0.192624801449186;0.00578711715259323;-0.0209586998909589;-0.493184724278463;-0.424232611000824;-0.730824739041110;-1.58631165195571;-0.0764803043844128;0.0346466617291832;-0.240013104897188;0.0302850704650872;-0.496213080697234;1.00920573095836;-3.06841444570998;-0.263209821902555;-0.407155203113707;-0.0613913563471029;0.304604236932631;0.266566657933230;-0.169391550418057;-2.18961920632103;-0.985119861734287;-0.499589857560864;-0.335603689954797;0.0436622536818941;-0.224477881997438;0.0713394733767140;-1.22559505794387;-0.332347153527214;-0.341454016046757;-0.251214341832529;-0.352519850642036;-0.582252551337782];
    
%     B_backup = [-1.14192427658216;-0.352895127618865;-1.92004682090433;0.588073514461441;0.245796905441639;-0.739510478636866;0.181781170901963;-4.21165249440397;0.937092817970570;-0.798883819910609;-1.82892274036048;0.0817498396566637;-1.22224855064166;-2.29471452363941;-0.0240841090360597;-1.51444606058167;-2.60316907765044;0.802518469223929;0.913256139905250;0.565882789239498;0.517262591286435;0.506060780690918;0.916591362929910;5.00023372838057;-0.384976942037480;-0.250783716197684;-0.246167337551433;0.361973469872925;-0.286618374965602;-0.394859905575444;0.0954218107299274;1.21275762224422;-1.42096643007132;0.640119233309817;-0.461535135154707;0.169190325255539;1.11406740125248;0.398913395488527;0.0917349284306399;4.10788914396583;1.05850619844810;1.39378722653566;1.08521355752758;-0.611337747894710;0.374369087826999;0.182825771779182;-0.223184170584905;-5.12342743180920;-0.0339718508836051;-1.72251955991476;-0.756993851509484;-0.513392700127299;-0.524086017176269;-0.0354781573741511;-0.212467745530651;-0.0205143585033457;-1.82855331219675;-0.336944892746703;-0.297260461703063;-0.544162440583058;-0.162399934669178;-0.239494433200316;-0.0758624604001313;-2.38486108327730;-1.05100425578171;-0.865547095677705;-0.499798151585160;0.223686820401276;-0.0610164133898231;0.143487091549943;-1.43661434506104;-0.111675303181137;-0.328194119880544;-0.511324201623670;-0.0670924055112519;-0.295336465935253;0.673596552399363;-2.61679982955367;-1.13014466576383;-0.923181704832996;-0.347060960289857;0.362363232902595;0.194884468511156;-1.27923043734901;-1.44787252394544;0.347248806587570;0.153311769029066;0.134721796975662;-0.344443917200159;-0.278769393551935;-0.568713245260318;-1.48572633660297;-0.161495141538576;-0.0416230418278816;-0.298899914674449;-0.0241946066707708;-0.526830069297912;0.530541678584010;-2.49599956284640;-0.419362298618120;-0.591195766708885;-0.280641328035007;0.0767529238716807;0.0325031015510989;0.199136589059064;-2.20704021450880;-0.976497319416837;-0.495159911348134;-0.330019663229341;0.0501694654747389;-0.220598348709697;-0.165844086036502;-1.23679677861121;-0.322902646341719;-0.329034921827317;-0.238735938619178;-0.341605524754495;-0.571431593374762];

%     EstimOpt.RealMin = 1;
    
%     Results.HMNL = HMNL(INPUT,Results,EstimOpt,OptimOpt);
    
   
    %% ****************************     HMXL     ****************************
    
% linear l: -18612.7877

B_backup = [-1.29357029450129;-0.0705039528502110;-1.90021076664603;0.541399341660914;0.618801578951232;-0.558489829964325;0.102636928261141;-1.97216985202462;0.915632044964730;1.16212638418486;-0.844086250014013;0.460966478825456;0.477682093688609;0.946387000643740;-0.361195157020909;2.90466010303809;0.310644691863189;-1.11125808644724;-1.20352874295124;0.448356746783710;-1.55624770922474;-1.83690159364015;0.316754571363907;-2.47502019324699;2.39941807194795;-0.803158727689322;-0.984504956351124;-0.466295098175813;-0.946876615754891;-1.13000796087293;-0.741291625692638;-4.35657786440478;-0.163765176661610;0.113384674164826;-0.308418401665838;0.247543075294545;0.125376544184686;-0.283254416002200;-0.0380668982250862;1.05739479466375;1.37536132686973;-0.360648322829374;0.128682904125629;-0.0829189237829112;-0.508679062168921;-0.173447207185408;-0.0719476720560957;-2.59444012946738;0.0339902973916073;0.943138279955138;1.77043171391902;-0.199466933580298;0.140146230009014;0.887939565594324;0.172084269139350;-3.03820902612524;0.0346260386888404;-1.72325862766192;-0.757777273092787;-0.512668952718275;-0.522546746322434;-0.0364060626543785;-0.213410183126460;-0.112229187473004;-1.84086336499201;-0.330146269982197;-0.290165563486840;-0.536656712048663;-0.157011940460596;-0.237758086391873;0.213622895805526;-2.43185653824351;-1.03265378571292;-0.851436898694026;-0.477786851797217;0.243773506768958;-0.0427009759667508;-0.318418298042693;-1.49453762208782;-0.0684899634691120;-0.289394537365574;-0.477870628852965;-0.0324346054180609;-0.251454282817941;0.696663468243948;-2.66736042360323;-1.11831981823002;-0.903911293634291;-0.327950773953884;0.375971434548436;0.205758107051053;-1.16263518476176;-1.35849521750801;0.293753388966702;0.103396537706694;0.0840617427101831;-0.389107483804141;-0.326115410162710;0.787070597760997;-1.63200134734768;-0.0519346710073746;0.0632998149766253;-0.207541822684445;0.0583535474461268;-0.466839220982175;-0.849838848332322;-2.84178648936362;-0.342330069261017;-0.476749292752386;-0.135980852790282;0.227491535936985;0.189044821937406;0.281822535991521;-2.23248761719209;-0.973970387586969;-0.487563326780400;-0.315700652244088;0.0716619897808374;-0.196798859796449;-0.215238012823749;-1.25369139736212;-0.305284609972299;-0.320156899754553;-0.235298716453599;-0.339208833005902;-0.568015268001538];

% linear l constrained: -18858.9314
B_tmp = reshape(B_backup(17:16+5*8),[8,5]);
B_tmp(2:7,:) = 0;
B_backup = [B_backup(1:16);B_tmp(:);B_backup(16+5*8+1:end)];
EstimOpt.BActive = B_backup ~= 0;
B_backup = [-1.20695452905892;0.157960684331521;-1.36267651479787;0.558744609786206;0.490713693675617;-0.349669882009251;0.228891665293837;-2.05492115149474;1.70131743691536;1.53945941420966;-1.97900091178439;0.764671165672735;1.14715829449977;1.61812757930567;-0.731875600725065;2.90613610034005;0.385591923695116;0;0;0;0;0;0;-2.51542077461610;2.87869981431055;0;0;0;0;0;0;-4.43625060908393;-0.362446598377022;0;0;0;0;0;0;1.40436815612704;0.956025323587034;0;0;0;0;0;0;-2.22693779663586;0.00423301964207999;0;0;0;0;0;0;-3.27994947827169;0.260835546870667;-1.78253563674682;-0.729498429869598;-0.482886562443100;-0.489413313757374;-0.000856831918973039;-0.183903984949751;-0.349380623560576;-1.93185430589915;-0.278556249982000;-0.238609015499607;-0.485344346115583;-0.105213400208112;-0.187500793072959;0.219027694233071;-2.42909757269010;-1.03367449504266;-0.854319261497551;-0.480307738251495;0.246391855710156;-0.0402668072494646;-0.235325601281084;-1.46589185395818;-0.0921836741788008;-0.309242953243359;-0.495072063782097;-0.0546838497633222;-0.277182251551689;0.785486240688018;-2.76794707030702;-1.07449218932329;-0.864890529598955;-0.293764212536654;0.415285957030507;0.249179946197900;-0.967702319540089;-1.23652570572371;0.195037973208116;0.00191248427199447;-0.0230872353538496;-0.490552862310340;-0.416477424934028;0.613257807847222;-1.50352396983802;-0.127453934433987;-0.0214326166692053;-0.296558419008032;-0.0285623835275396;-0.552473941871622;-1.47409296425188;-3.82636778880081;-0.0471895980100059;-0.186712279351311;0.158662091107745;0.527245908366527;0.494120978204301;0.520761790222664;-2.42791743231296;-0.889622102172671;-0.408339506780558;-0.239428070807607;0.153685283474941;-0.113734019396051;-0.466821275614342;-1.34577607594833;-0.225383466392715;-0.243313301150292;-0.162397859397824;-0.271988420474837;-0.507724561874290];

% poprawione znaki SQ-C i SQ-O, start z: -18858.9314

B_backup = [-1.20695452905892;0.157960684331521;-1.36267651479787;0.558744609786206;0.490713693675617;-0.349669882009251;0.228891665293837;-2.05492115149474;1.70131743691536;1.53945941420966;-1.97900091178439;0.764671165672735;1.14715829449977;1.61812757930567;-0.731875600725065;2.90613610034005;0.385591923695116;0;0;0;0;0;0;-2.51542077461610;2.87869981431055;0;0;0;0;0;0;-4.43625060908393;0.500000000000000;0;0;0;0;0;0;1.40436815612704;0.956025323587034;0;0;0;0;0;0;-2.22693779663586;-0.500000000000000;0;0;0;0;0;0;-3.27994947827169;0.260835546870667;-1.78253563674682;-0.729498429869598;-0.482886562443100;-0.489413313757374;-0.000856831918973039;-0.183903984949751;-0.349380623560576;-1.93185430589915;-0.278556249982000;-0.238609015499607;-0.485344346115583;-0.105213400208112;-0.187500793072959;0.219027694233071;-2.42909757269010;-1.03367449504266;-0.854319261497551;-0.480307738251495;0.246391855710156;-0.0402668072494646;-0.235325601281084;-1.46589185395818;-0.0921836741788008;-0.309242953243359;-0.495072063782097;-0.0546838497633222;-0.277182251551689;0.785486240688018;-2.76794707030702;-1.07449218932329;-0.864890529598955;-0.293764212536654;0.415285957030507;0.249179946197900;-0.967702319540089;-1.23652570572371;0.195037973208116;0.00191248427199447;-0.0230872353538496;-0.490552862310340;-0.416477424934028;0.613257807847222;-1.50352396983802;-0.127453934433987;-0.0214326166692053;-0.296558419008032;-0.0285623835275396;-0.552473941871622;-1.47409296425188;-3.82636778880081;-0.0471895980100059;-0.186712279351311;0.158662091107745;0.527245908366527;0.494120978204301;0.520761790222664;-2.42791743231296;-0.889622102172671;-0.408339506780558;-0.239428070807607;0.153685283474941;-0.113734019396051;-0.466821275614342;-1.34577607594833;-0.225383466392715;-0.243313301150292;-0.162397859397824;-0.271988420474837;-0.507724561874290];
% i nie zmienia si?: -18858.9314
B_backup = [-1.20695437477236;0.157960563597752;-1.36267643196759;0.558744667461032;0.490713839015427;-0.349669874686041;0.228891531879621;-2.05492114617702;1.70131769989571;1.53945936103048;-1.97900095205239;0.764671036323806;1.14715790853761;1.61812724898134;-0.731875842098501;2.90613610775019;0.385591974775856;0;0;0;0;0;0;-2.51542076884359;2.87869920241879;0;0;0;0;0;0;-4.43625049622188;-0.362446590914136;0;0;0;0;0;0;1.40436814519912;0.956025259995169;0;0;0;0;0;0;-2.22693781351857;0.00423301803885282;0;0;0;0;0;0;-3.27994945693399;0.260835782272287;-1.78253583641740;-0.729498323358671;-0.482886402391213;-0.489413235811048;-0.000856776604871304;-0.183903783500228;-0.349380844023488;-1.93185459194093;-0.278555957231369;-0.238608959357245;-0.485344268588975;-0.105213335720936;-0.187500729570498;0.219027779489362;-2.42909889597258;-1.03367063175655;-0.854318942240940;-0.480308125001312;0.246391895560911;-0.0402667692536745;-0.235325621964528;-1.46589183337989;-0.0921837069419915;-0.309242948794372;-0.495071991209011;-0.0546839060160180;-0.277182285526047;0.785486311440605;-2.76794670073202;-1.07449278716083;-0.864891612078551;-0.293763917387632;0.415286024983926;0.249179943917875;-0.967702172873308;-1.23652565180374;0.195037924717076;0.00191239297649759;-0.0230872235846737;-0.490552952724340;-0.416477820947500;0.613257832660965;-1.50352400018459;-0.127453904807426;-0.0214326253620398;-0.296558367310519;-0.0285623855015538;-0.552473757281549;-1.47409294787586;-3.82636717267256;-0.0471901394757494;-0.186712397216095;0.158662059147870;0.527245974122084;0.494120905974953;0.520761965954090;-2.42791801922642;-0.889621470529018;-0.408339236924804;-0.239427948118480;0.153685350603969;-0.113733937899731;-0.466821153144821;-1.34577596117106;-0.225383522494132;-0.243313388351032;-0.162397964621681;-0.271988396903760;-0.507724575355463];
%     EstimOpt.ProjectName = '5c';

EstimOpt.RealMin = 1;

    Results.HMXL_d = HMXL(INPUT,Results,EstimOpt,OptimOpt);
    
    sendmail('mik@czaj.org','MATLAB: WNE - done!');
    
catch theErrorInfo
    
    sendmail('mik@czaj.org','MATLAB: WNE - error!',theErrorInfo.message);
    
end

